<?php
# version: 3.1, build 06
# Date: Aug 20, 2008, 16:27pm
# Filename: flexlm_poller_v3.1.php
# Description: Poll FLEXlm licenses usage and write to file.
# This version gathered data and write back to a text file.

include "flexlm_server_config.php";         // This is the FLEXlm server configuration.
include "flexlm_poller_config.php";         // This is the configuration file.
include "flexlm_function.php";              // FLEXlm functions library.
include "array_to_file.php";                // Library to write back to file.

$flexlm_licenses = $servers;

foreach ($servers as $server => $ports) {
	foreach ($ports as $port) {
		$lmstat_result = get_lmstat($server, $port);

		$featureflag = 0; $userflag = 0; $specialflag = 0; $feature = "unknown";
		$usedcounter = 0; $counter = 0;
		foreach ($lmstat_result as $line) {
			if ( preg_match('/(Users of) (.*):\s+(\(Uncounted, node-locked\))/i', $line, $out) && !eregi("No such feature exists", $line) ) {
				// Users of certitude-simulation:  (Uncounted, node-locked)
				// New feature found. Special feature "Uncounted, node-locked"
				$featureflag = 1; $specialflag = 1; $userflag = 0;
				$feature = $out[2]; $total = 0; $inuse = 0;
				// Initialize array.
				$flexlm_licenses[$server][$port][$feature] = "";
				$flexlm_licenses[$server][$port][$feature][$total_license] = $total;
				$flexlm_licenses[$server][$port][$feature][$license_in_used] = $inuse;
			}
			else if ( preg_match('/(Users of) (.*):\s+(\(Total of) (\d+) (.*) (Total of) (\d+) /i', $line, $out) && !eregi("No such feature exists", $line) ) {
				// Users of STSEAT11:  (Total of 92 licenses issued;  Total of 91 licenses in use)
				// New feature found. Normal feature.
				$featureflag = 1; $specialflag = 0; $userflag = 0;
				$feature = $out[2]; $total = $out[4]; $inuse = $out[7];
				// Initialize array.
				$flexlm_licenses[$server][$port][$feature] = "";
				$flexlm_licenses[$server][$port][$feature][$total_license] = $total;
				$flexlm_licenses[$server][$port][$feature][$license_in_used] = $inuse;
			}
			else if ( eregi(", start", $line ) ) {
				if ($specialflag == 1)
					$flexlm_licenses[$server][$port][$feature][$license_in_used] += 1;
			}
			else if ( eregi(" RESERVATION", $line ) ){
				$featureflag = 0; $userflag = 1;
				if ($specialflag == 1)
					$flexlm_licenses[$server][$port][$feature][$license_in_used] += $out[1];
			}
		} // foreach ($lmstat_result as $line)
		ksort($flexlm_licenses[$server][$port]);
	} // foreach (array_keys($servers[$server]) as $port)
} // foreach ($servers as $server)


// Write result to file in order for flexlm_query to query on.
$file=fopen($flexlm_result,"w");
fwrite($file,"<?php\r\n");
set_array_to_file($file,$servers,"\$servers");
set_array_to_file($file,$servers_flexlm_vendor,"\$servers_flexlm_vendor");
set_array_to_file($file,$flexlm_licenses,"\$flexlm_licenses");
fwrite($file,"?>");

?>